Bugzilla 1402 - Handle upper case chars in tests
[exim.git] / src / scripts / Configure-Makefile
CommitLineData
61ec970d 1#! /bin/sh
61ec970d
PH
2
3# Shell script to build Makefile in a build directory. It must be called
4# from inside the directory. It does its own checking of when to rebuild; it
5# just got too horrendous to get it right in "make", because of the optionally
6# existing configuration files.
7
8
9# First off, get the OS type, and check that there is a make file for it.
10
11ostype=`../scripts/os-type -generic` || exit 1
12
13if [ ! -r ../OS/Makefile-$ostype ] ; then
14 echo ""
15 echo "*** Sorry - operating system $ostype is not supported"
16 echo "*** See OS/Makefile-* for supported systems" 1>&2
17 echo ""
18 exit 1
19fi
20
21# We also need the architecture type, in order to test for any architecture-
22# specific configuration files.
23
24archtype=`../scripts/arch-type` || exit 1
25
26# Now test for either the non-existence of Makefile, or for any of its
27# components being newer. Note that the "newer" script gives the right
28# answer (for our purposes) when the first file is non-existent.
29
30editme=../Local/Makefile
31rebuild=yes
32
33if [ -f Makefile ] ; then
34 rebuild=no
35 if ../scripts/newer $editme Makefile || \
36 ../scripts/newer $editme-$ostype Makefile || \
37 ../scripts/newer $editme-$archtype Makefile || \
38 ../scripts/newer $editme-$ostype-$archtype Makefile || \
39 ../scripts/newer ../scripts/Configure-Makefile Makefile || \
40 ../scripts/newer ../OS/Makefile-Base Makefile || \
41 ../scripts/newer ../OS/Makefile-Default Makefile
42 then
43 rebuild=yes
44 fi
45fi
46
47# If the "build" variable is set it means that a build name was explicitly
48# given. Arrange to pick up a build-specific configuration file.
49
50if [ "X$build" != "X" ] ; then
51 mfb=Local/Makefile-$build
52 if ../scripts/newer $editme-$build Makefile ; then
53 rebuild=yes
54 fi
55else
56 mfb=
57fi
58
59
60# If Makefile is up-to-date, no need to rebuild it.
61
62if [ $rebuild = no ] ; then
63 echo "\`Makefile' is up to date."
64 echo " "
65 exit
66fi
67
68# Makefile needs to be rebuilt in the current directory by joining
69# the generic default makefile, the OS base makefile, and then local
70# generic, OS-specific, architecture-specific, and OS+architecture-specific
71# makefiles, if they exist. These files all contain macro definitions, with
72# later definitions overriding earlier ones. Make a temporary file first, in
73# case things go wrong. A second temporary is needed for sorting out the
74# default Perl stuff. Use short macro names to save typing.
75
76mf=Makefile
77mft=$mf-t
78mftt=$mf-tt
79
58ee1eb6
TF
80look_mf=lookups/Makefile
81look_mf_pre=${look_mf}.predynamic
82look_mf_post=${look_mf}.postdynamic
0a349494 83
61ec970d
PH
84# Ensure the temporary does not exist and start the new one by setting
85# the OSTYPE and ARCHTYPE variables.
86
0a349494 87rm -f $mft $mftt $look_mf-t
61ec970d
PH
88(echo "OSTYPE=$ostype"; echo "ARCHTYPE=$archtype"; echo "") > $mft || exit 1
89
90# Now concatenate the files to the temporary file. Copy the files using sed to
91# remove comments, blank lines, and trailing white space.
92
93# BEWARE: a tab character is needed in the sed command below. It has had
94# a nasty tendency to get lost in the past, causing a problem if a tab has
95# actually been present in one of the files. Use a variable to hold a space
96# and a tab to keep the tab in one place.
97
98st=' '
99
100for f in OS/Makefile-Default \
101 OS/Makefile-$ostype \
102 Local/Makefile \
103 Local/Makefile-$ostype \
104 Local/Makefile-$archtype \
105 Local/Makefile-$ostype-$archtype \
106 $mfb
107do if test -r ../$f
108 then echo "# From $f"
109 sed "/^#/d;/^[$st]*\$/d;s/[$st]*\$//" ../$f || exit 1
110 echo "# End of $f"
111 echo ""
112 fi
0a349494
PP
113done >> $mft || exit 1
114
dde3daac
PP
115# handle pkg-config
116# beware portability of extended regexps with sed.
117
118egrep "^[$st]*(AUTH|LOOKUP)_[A-Z0-9_]*[$st]*=[$st]*" $mft | \
119 sed "s/[$st]*=/='/" | \
120 sed "s/\$/'/" > $mftt
6a6084f8 121egrep "^[$st]*((USE_(OPENSSL|GNUTLS)_PC)|SUPPORT_TLS|USE_GNUTLS|PCRE_CONFIG)[$st]*=[$st]*" $mft | \
f4b00a2d
PP
122 sed "s/[$st]*=/='/" | \
123 sed "s/\$/'/" >> $mftt
dde3daac
PP
124if test -s $mftt
125then
126 (
127 echo "# pkg-config fixups"
128 . ./$mftt
129 for var in `cut -d = -f 1 < $mftt`; do
130 case $var in
f4b00a2d
PP
131
132 USE_*_PC)
133 eval "pc_value=\"\$$var\""
134 need_this=''
135 if [ ".$SUPPORT_TLS" = "." ]; then
136 # no TLS, not referencing
137 true
138 elif [ ".$var" = ".USE_GNUTLS_PC" ] && [ ".$USE_GNUTLS" != "." ]; then
139 need_this=t
140 elif [ ".$var" = ".USE_OPENSSL_PC" ] && [ ".$USE_GNUTLS" = "." ]; then
141 need_this=t
142 fi
143 if [ ".$need_this" != "." ]; then
144 tls_include=`pkg-config --cflags $pc_value`
145 tls_libs=`pkg-config --libs $pc_value`
146 echo "TLS_INCLUDE=$tls_include"
147 echo "TLS_LIBS=$tls_libs"
148 fi
149 ;;
150
dde3daac
PP
151 *_PC)
152 eval "pc_value=\"\$$var\""
153 base=`echo $var | sed 's/_PC$//'`
154 eval "basevalue=\"\$$base\""
155 if [ ".$basevalue" = "." ]; then
156 # not pulling in this module, _PC defined as default? Ignore
157 true
158 elif [ $basevalue = 2 ]; then
159 # module; handled in scripts/lookups-Makefile
160 true
161 else
162 # main binary
163 cflags=`pkg-config --cflags $pc_value`
164 libs=`pkg-config --libs $pc_value`
165 if [ "$var" != "${var#LOOKUP_}" ]; then
166 echo "LOOKUP_INCLUDE += $cflags"
167 echo "LOOKUP_LIBS += $libs"
168 elif [ "$var" != "${var#AUTH_}" ]; then
169 echo "CFLAGS += $cflags"
170 echo "AUTH_LIBS += $libs"
171 else
172 echo >&2 "Don't know how to handle pkg-config for $var"
173 fi
174 fi
175 ;;
f4b00a2d 176
6a6084f8
PP
177 PCRE_CONFIG)
178 case $PCRE_CONFIG in
179 yes|YES|y|Y)
180 cflags=`pcre-config --cflags`
181 libs=`pcre-config --libs`
182 if [ ".$cflags" != "." ]; then
183 echo "INCLUDE += $cflags"
184 fi
185 echo "PCRE_LIBS=$libs"
186 ;;
187 esac
188 ;;
189
dde3daac
PP
190 esac
191 done
192 echo "# End of pkg-config fixups"
193 echo
194 ) >> $mft
195fi
196rm -f $mftt
197
0a349494 198# make the lookups Makefile with the definitions
58ee1eb6 199# the auxiliary script generates $look_mf_post from $look_mf_pre
0a349494 200
58ee1eb6
TF
201cp ../src/lookups/Makefile $look_mf_pre
202../scripts/lookups-Makefile
61ec970d
PH
203
204# See if there is a definition of EXIM_PERL in what we have built so far.
205# If so, run Perl to find the default values for PERL_CC, PERL_CCOPTS,
206# and PERL_LIBS. These need to be put at the top of the Makefile, so we rename
207# what we have so far and then copy it afterwards. Use the value of PERL_COMMAND
208# if it has been defined.
209
210EXIM_PERL=`grep EXIM_PERL $mft`
211
212PERL_COMMAND=`grep PERL_COMMAND $mft | sed -e "\\$!d;s/^[$st]*PERL_COMMAND[$st]*=[$st]*//"`
213if [ "${PERL_COMMAND}" = "" ] ; then
214 PERL_COMMAND='perl'
215fi
216
217if [ "${EXIM_PERL}" != "" ] ; then
218 testperl=`$PERL_COMMAND --version`
219 if [ "$testperl" = "" ] ; then
220 echo "*** EXIM_PERL is set, but '$PERL_COMMAND --version' failed"
221 exit 1
222 fi
223
177ebd9b
NM
224 EXTUTILS_EMBED_NOT_INSTALLED=`$PERL_COMMAND -MExtUtils::Embed -e ";" 2>&1`
225 if [ "${EXTUTILS_EMBED_NOT_INSTALLED}" != "" ] ; then
226 echo "Please install ExtUtils::Embed for $PERL_COMMAND"
227 exit 1;
228 fi
229
61ec970d
PH
230 mv $mft $mftt
231 echo "PERL_CC=`$PERL_COMMAND -MConfig -e 'print $Config{cc}'`" >>$mft
232 echo "PERL_CCOPTS=`$PERL_COMMAND -MExtUtils::Embed -e ccopts`" >>$mft
233 echo "PERL_LIBS=`$PERL_COMMAND -MExtUtils::Embed -e ldopts`" >>$mft
234 echo "" >>$mft
235 cat $mftt >> $mft
236 rm -f $mftt
237fi
238
239# Record the build variable in the Makefile.
240
241echo "build=$build" >>$mft
242echo "" >>$mft
243
244# Finally, join on the generic base make file, which contains the actual
245# rules and stuff.
246
76ea0716 247echo "# From ../OS/Makefile-Base" >> $mft
61ec970d
PH
248cat ../OS/Makefile-Base >> $mft || exit 1
249
250# If the new makefile is the same as the existing one, say so, and just
251# update the timestamp. Otherwise remove the old and install the new.
252
58ee1eb6 253if [ -s $mf ] && cmp -s $mft $mf && [ -s $look_mf ] && cmp -s $look_mf_post $look_mf
61ec970d
PH
254then echo ">>> rebuilt $mf unchanged"
255 echo " "
256 touch $mf || exit
58ee1eb6
TF
257 rm -f $mft $look_mf_pre $look_mf_post
258elif rm -f $mf $look_mf $look_mf_pre
61ec970d 259 mv $mft $mf
58ee1eb6 260 mv $look_mf_post $look_mf
0a349494 261then echo ">>> New $mf & $look_mf installed"
61ec970d
PH
262 echo '>>> Use "make makefile" if you need to force rebuilding of the makefile'
263 echo " "
264else echo " "
265 echo "*** Failed to install $mf - see $mft"
0a349494 266 echo " (or $look_mft)"
61ec970d
PH
267 echo " "
268 exit 1;
269fi
270
dde3daac 271# vim: set ft=sh :
61ec970d 272# End of Configure-Makefile